module Mycrm
  module CoreExt
    class Address
      FIELDS = [:formatted, :street, :suburb, :state, :postcode, :country]

      attr_reader *FIELDS

      alias to_s formatted

      def initialize(formatted, locale = :en_au)
        @formatted = formatted
        expand(locale)
      end

      def to_h
        FIELDS.reject{ |f| f == :formatted }.each_with_object({}){ |f, out| out[f] = send(f) }
      end

      private

      def expand(locale)
        @street, @suburb, @state, @postcode, @country = *formatted.split(',').map(&:strip)
      end
    end
  end
end
