require 'mycrm/core_ext/address'

module Mycrm
  module CoreExt
    module String
      def to_underscore
        self.to_s.gsub(/::/, '/')
          .gsub(/([A-Z]+)([A-Z][a-z])/,'\1_\2')
          .gsub(/([a-z\d])([A-Z])/,'\1_\2')
          .tr("-", "_")
          .downcase
      end

      def to_camelized
        return self if self.to_s !~ /_/ && self.to_s =~ /[A-Z]+.*/
        self.to_s.split('_').collect(&:capitalize).join
      end

      def to_address
        Mycrm::CoreExt::Address.new(self)
      end
    end
  end
end
