require_relative '../facade'
require_relative '../models/client'
require_relative '../models/note'
require_relative '../models/adviser_note'

module Mycrm
  module Facades
    class Lead
      include Facade

      delegate :client, Mycrm::Models::Client
      delegate :note, Mycrm::Models::Note, family_id: 'client.family_id'
      delegate :adviser_note, Mycrm::Models::AdviserNote, family_id: 'client.family_id'

      def create
        run { |instance| instance.create }.values.all?
      end

      def create!
        run { |instance| instance.create! }
      end
    end
  end
end
