require_relative '../facade'
require_relative '../models/client'
require_relative '../models/note'
require_relative '../models/adviser_note'
require_relative '../models/application'
require_relative '../models/structure'

module Mycrm
  module Facades
    class LeadApplication
      include Facade

      delegate :client, Mycrm::Models::Client
      delegate :note, Mycrm::Models::Note, family_id: 'client.family_id'
      delegate :adviser_note, Mycrm::Models::AdviserNote, family_id: 'client.family_id'
      delegate :application, Mycrm::Models::Application, client_id: 'client.id'
      delegate :structure, Mycrm::Models::Structure, application_id: 'application.id'

      def create
        run { |instance| instance.create }.values.all?
      end

      def create!
        run { |instance| instance.create! }
      end
    end
  end
end
