require_relative '../model'
require_relative '../attributes/deposit'

module Mycrm
  module Models
    # leads
    class Application
      include Model

      endpoint 'lm-clients/%{client_id}/scenarios'

      only :post

      attribute :id, Integer
      attribute :client_id, Integer
      attribute :deposit, Mycrm::Attributes::Deposit, embedded: true
      attribute :salesforce_id, String
      attribute :converted, Boolean, default: false
      attribute :purposes, Array[Integer]
      attribute :features, Array[Integer]
      attribute :preferred_lenders, Array[Integer]
      attribute :scenario_name, String
      attribute :specific_goals, String
      attribute :has_settlement_date, Boolean, default: true
      attribute :settlement_date, String, default: lambda { |_,_| DateTime.now.to_s }
      attribute :applicants, Array[Hash[Symbol => Integer]]
      attribute :metadata, String

      def add_purpose(purpose)
        self.purposes << Mycrm::Domains::Purposes.find(purpose)
      end

      def add_feature(feature)
        self.features << Mycrm::Domains::LoanFeatures.find(feature)
      end
    end
  end
end
