require_relative '../model'
require_relative '../attributes/name'
require_relative '../attributes/date'
require_relative '../attributes/address'

module Mycrm
  module Models
    # leads
    class Client
      include Model

      endpoint 'lm-clients'

      attribute :id, Integer
      attribute :active, Boolean, default: true
      attribute :role_id, Integer, default: 1
      attribute :source_id, Integer
      attribute :family_id, Integer
      attribute :allocated_broker_id, Integer
      attribute :consumer_uuid, String
      attribute :broker_uuid, String

      attribute :name, Mycrm::Attributes::Name, embedded: true
      attribute :dob, Mycrm::Attributes::Date, embedded: true
      attribute :address, Mycrm::Attributes::Address, embedded: true
      attribute :allocation_postcode, String
      attribute :email, String
      attribute :mobile, String
      attribute :mobile_validated, Boolean, default: true
      attribute :utm, Hash[Symbol => String]

      attribute :web_lead_url, String
      attribute :web_landing_url, String

      def source=(source)
        self.source_id = Mycrm::Domains::Sources.find(source) rescue nil
      end
    end
  end
end
