require_relative '../model'

module Mycrm
  module Models
    class Office
      include Model

      endpoint 'corporate/AdviserOrganizationGet'

      only :get

      to :underscore

      attribute :AdviserOrganizationId, Integer, as: :id

      attribute :AdviserOrganizationName, String, as: :name
      attribute :RegisteredBusinessName, String
      attribute :TradingName, String
      attribute :OfficeDisplayName, String, as: :display_name

      attribute :Phone, String
      attribute :Fax, String
      attribute :CompanyEmail, String, as: :email
      attribute :ABN, String
      attribute :ACN, String
      attribute :ASCId, String, as: :asic_id
      attribute :Website, String

      attribute :AccountOwner_FamilyId, Integer, as: :owner_id
      attribute :AccountOwner_FullName, String, as: :owner_name

      attribute :LeadAdviser_FamilyId, Integer, as: :lead_adviser_id
      attribute :LeadAdviser_FullName, String, as: :lead_adviser_name

      attribute :IsActive, Boolean

      def self.find(id)
        find_by_AdviserOrganizationId(id)
      end

      def self.parse(body)
        parsed = JSON.parse(body)
        raise Mycrm::ResponseError, 'No Office Found' if parsed.empty?
        parsed.first
      end
    end
  end
end
