require_relative '../model'

module Mycrm
  module Models
    class OfficeAddress
      include Model

      endpoint 'corporate/OrganizationAddressGet'

      only :get

      to :underscore

      attribute :organizationId, Integer
      attribute :Route, String, as: :street_name
      attribute :Subpremise, String
      attribute :Street_number, String
      attribute :Postal_code, String
      attribute :Locality, String, as: :suburb
      attribute :Administrative_area_level_1, String, as: :state
      attribute :Country, String
      attribute :Formatted_address, String, as: :formatted
      attribute :Latitude, Float
      attribute :Longitude, Float
      attribute :GeoCoded, Boolean
      attribute :IsMailing, Boolean

      def self.find(id)
        find_by_organizationId(id)
      end

      def self.parse(body)
        JSON.parse(body).find{ |address| !address['isMailing'] } || {}
      end
    end
  end
end
